(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("rxjs"), require("rxjs/operators"));
	else if(typeof define === 'function' && define.amd)
		define("react-rxjs-elements", ["react", "rxjs", "rxjs/operators"], factory);
	else if(typeof exports === 'object')
		exports["react-rxjs-elements"] = factory(require("react"), require("rxjs"), require("rxjs/operators"));
	else
		root["react-rxjs-elements"] = factory(root["react"], root["rxjs"], root["rxjs"]["operators"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_react__, __WEBPACK_EXTERNAL_MODULE_rxjs__, __WEBPACK_EXTERNAL_MODULE_rxjs_operators__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/elements.ts":
/*!*************************!*\
  !*** ./src/elements.ts ***!
  \*************************/
/*! exports provided: $a, $img, $p, $span, $div, $textarea, $input, $form, $button, createElement$ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$a\", function() { return $a; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$img\", function() { return $img; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$p\", function() { return $p; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$span\", function() { return $span; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$div\", function() { return $div; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$textarea\", function() { return $textarea; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$input\", function() { return $input; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$form\", function() { return $form; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$button\", function() { return $button; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"createElement$\", function() { return createElement$; });\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs/operators */ \"rxjs/operators\");\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var _fragment__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./fragment */ \"./src/fragment.ts\");\n\n\n\n\n// preset elements {{{\n// Q: should we prefab all possible elements?\n// Q: should that be statically generated on build or created on demand?\nvar $a = createElement$('a');\nvar $img = createElement$('img');\nvar $p = createElement$('p');\nvar $span = createElement$('span');\nvar $div = createElement$('div');\nvar $textarea = createElement$('textarea');\nvar $input = createElement$('input');\nvar $form = createElement$('form');\nvar $button = createElement$('button');\n// }}}\nvar EMPTY_DEPENDENCIES = [];\nvar useEmptyObject = function () { return Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useMemo\"])(function () { return Object.create(null); }, EMPTY_DEPENDENCIES); };\nfunction createElement$(elName) {\n    var el$ = function (_props) {\n        // TODO: consider extracting static props and immediately using them\n        var _a = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(Object.create(null)), props = _a[0], setProps = _a[1];\n        // placeholder for Observable.error case -- will use it to rethrow error\n        var _b = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"])(null), error = _b[0], setError = _b[1];\n        // destroy$ stream helper {{{\n        // it will emit an empty value on unmount\n        var destroy$ = Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useMemo\"])(function () { return new rxjs__WEBPACK_IMPORTED_MODULE_1__[\"Subject\"](); }, EMPTY_DEPENDENCIES);\n        Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"])(function () { return function () {\n            destroy$.next(void 0);\n            destroy$.complete();\n        }; }, EMPTY_DEPENDENCIES);\n        // }}}\n        // store prev props to compare\n        var _prevProps = useEmptyObject();\n        // keep subscriptions to unsubscribe on dynamic prop update\n        var _subs = useEmptyObject();\n        // use effect for props\n        Object(react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"])(function () {\n            // check for obsolete props\n            var delProps = Object.create(null);\n            Object.keys(_prevProps).forEach(function (key) {\n                if (!(key in _props)\n                    || !Object.is(_props[key], _prevProps[key])) {\n                    delete _prevProps[key];\n                    if (_subs[key]) {\n                        _subs[key].unsubscribe();\n                        delete _subs[key];\n                    }\n                    // remove from static props\n                    delProps[key] = void 0;\n                }\n            });\n            // immediately remove obsolete props\n            setProps(function (p) { return Object.assign({}, p, delProps); });\n            // update/track new props\n            var nextProps = Object.create(null);\n            Object.keys(_props).forEach(function (key) {\n                // TODO: add Observable ref\n                if (key == 'children' || key == 'ref') {\n                    return;\n                }\n                var value = _props[key];\n                _prevProps[key] = value;\n                // all onSomething -- are considered to be output props\n                if (/^on[A-Z]/.test(key) && typeof value.next == 'function') {\n                    setProps(function (p) {\n                        var _a;\n                        return Object.assign({}, p, (_a = {},\n                            _a[key] = function (e) { return value.next(e); },\n                            _a));\n                    });\n                }\n                // observable input params are auto observed\n                else if (Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"isObservable\"])(value)) {\n                    _subs[key] = value.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"takeUntil\"])(destroy$)).subscribe({\n                        // on value updates -- update props\n                        next: function (data) {\n                            setProps(function (p) {\n                                var _a;\n                                return Object.assign({}, p, (_a = {}, _a[key] = data, _a));\n                            });\n                        },\n                        // on error -- rethrow error\n                        error: function (error) {\n                            setError({ error: error });\n                        }\n                    });\n                }\n                // all static props are directly updated\n                else {\n                    nextProps[key] = value;\n                }\n            });\n            // update static props\n            setProps(function (p) { return Object.assign({}, p, nextProps); });\n        }, [_props]);\n        // if error -- throw\n        if (error) {\n            throw error.error;\n        }\n        return Object(react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"])(elName, props, \n        // if children exist\n        // they might be observable\n        // so we pass em to <$> fragment\n        _props.children\n            ? Object(react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"])(_fragment__WEBPACK_IMPORTED_MODULE_3__[\"$\"], null, _props.children)\n            : null);\n    };\n    return el$;\n}\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/elements.ts?");

/***/ }),

/***/ "./src/fragment.ts":
/*!*************************!*\
  !*** ./src/fragment.ts ***!
  \*************************/
/*! exports provided: $ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"$\", function() { return $; });\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ \"react\");\n/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\nvar __spreadArrays = (undefined && undefined.__spreadArrays) || function () {\n    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;\n    for (var r = Array(s), k = 0, i = 0; i < il; i++)\n        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)\n            r[k] = a[j];\n    return r;\n};\n\n\nfunction $(props) {\n    var children = props === null || props === void 0 ? void 0 : props.children;\n    // store children\n    var _a = react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"](null), cn = _a[0], setCn = _a[1];\n    var _b = react__WEBPACK_IMPORTED_MODULE_0__[\"useState\"](null), error = _b[0], setError = _b[1];\n    react__WEBPACK_IMPORTED_MODULE_0__[\"useEffect\"](function () {\n        // multiple children, one of em might be observable\n        if (Array.isArray(children)) {\n            setCn(children.map(function (c) { return react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"]($, null, c); }));\n            return;\n        }\n        // single observable child\n        if (Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"isObservable\"])(children)) {\n            var sub_1 = children.subscribe({\n                next: function (cn) {\n                    // update the view\n                    setCn(cn);\n                },\n                error: function (error) {\n                    // wrap error in an object to be safe in case the error is nullish\n                    setError({ error: error });\n                }\n            });\n            return function () { return sub_1.unsubscribe(); };\n        }\n        // child is just a child\n        setCn(children);\n    }, [children]);\n    // raise an error if Observable failed\n    if (error) {\n        throw error.error;\n    }\n    // render children as array\n    return Array.isArray(cn)\n        ? react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"].apply(react__WEBPACK_IMPORTED_MODULE_0__, __spreadArrays([react__WEBPACK_IMPORTED_MODULE_0__[\"Fragment\"], null], cn)) : react__WEBPACK_IMPORTED_MODULE_0__[\"createElement\"](react__WEBPACK_IMPORTED_MODULE_0__[\"Fragment\"], null, cn);\n}\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/fragment.ts?");

/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: $a, $img, $p, $span, $div, $textarea, $input, $form, $button, createElement$, $ */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _elements__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./elements */ \"./src/elements.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$a\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$a\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$img\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$img\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$p\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$p\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$span\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$span\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$div\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$div\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$textarea\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$textarea\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$input\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$input\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$form\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$form\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$button\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"$button\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"createElement$\", function() { return _elements__WEBPACK_IMPORTED_MODULE_0__[\"createElement$\"]; });\n\n/* harmony import */ var _fragment__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./fragment */ \"./src/fragment.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"$\", function() { return _fragment__WEBPACK_IMPORTED_MODULE_1__[\"$\"]; });\n\n\n\n\n\n//# sourceURL=webpack://react-rxjs-elements/./src/index.ts?");

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_react__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%22react%22?");

/***/ }),

/***/ "rxjs":
/*!************************************************************************************!*\
  !*** external {"root":["rxjs"],"commonjs":"rxjs","commonjs2":"rxjs","amd":"rxjs"} ***!
  \************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%7B%22root%22:%5B%22rxjs%22%5D,%22commonjs%22:%22rxjs%22,%22commonjs2%22:%22rxjs%22,%22amd%22:%22rxjs%22%7D?");

/***/ }),

/***/ "rxjs/operators":
/*!******************************************************************************************************************************!*\
  !*** external {"root":["rxjs","operators"],"commonjs":"rxjs/operators","commonjs2":"rxjs/operators","amd":"rxjs/operators"} ***!
  \******************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs_operators__;\n\n//# sourceURL=webpack://react-rxjs-elements/external_%7B%22root%22:%5B%22rxjs%22,%22operators%22%5D,%22commonjs%22:%22rxjs/operators%22,%22commonjs2%22:%22rxjs/operators%22,%22amd%22:%22rxjs/operators%22%7D?");

/***/ })

/******/ });
});